#include "defs.h"
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

long read_num(FILE *f)
{
  long ret;
  int c;
  do c = fgetc(f); while (c != EOF && !isdigit(c)); if (c == EOF) abort();
  ungetc(c, f);
  if (fscanf(f, "%ld", &ret) != 1) abort();
  return ret;
}

void read_sub(FILE *f, sub *s)
{
  int n = s->cur.n;
  int c;
  int i, j, v;
  do c = fgetc(f); while (c != EOF && c != '('); if (c == EOF) abort();
  for (i = 0; i < n; i++) for (j = 0; j < n; j++) {
    v = read_num(f);
    s->best.row[v-1] = i;
    s->best.col[v-1] = j;
  }
}

void update_sub(sub *cur, FILE *f)
{
  sub s = *cur;
  read_sub(f, &s);
  e(&s.best);
  if (cur->best.t == TMIN && cur->best.e > s.best.e) cur->best = s.best;
  if (cur->best.t == TMAX && cur->best.e < s.best.e) cur->best = s.best;
}

void update_best(problem *p, char *best)
{
  int sub;
  FILE *f = fopen(best, "r");
  if (f == NULL) { perror(best); exit(1); }

  for (sub = 3; sub <= 27; sub++) {
    update_sub(&p->s[sub*2], f);
    update_sub(&p->s[sub*2+1], f);
  }

  fclose(f);
}

int saturation_permute(sub *ss)
{
  int ret = 0;
  int n0, n1;
  state s;
  state smin = ss->best;
more:
  for (n0 = 0; n0 < ss->best.n * ss->best.n; n0++) {
    for (n1 = n0+1; n1 < ss->best.n * ss->best.n; n1++) {
      s = ss->best;
      s.row[n0] = ss->best.row[n1];
      s.col[n0] = ss->best.col[n1];
      s.row[n1] = ss->best.row[n0];
      s.col[n1] = ss->best.col[n0];
      e(&s);
      if ((ss->best.t == TMIN && s.e < smin.e) ||
          (ss->best.t == TMAX && s.e > smin.e)) smin = s;
    }
  }
  /* better state than current best? */
  if ((ss->best.t == TMIN && smin.e < ss->best.e) ||
      (ss->best.t == TMAX && smin.e > ss->best.e)) {
    ret = 1;
    ss->best = smin;
    goto more;
  }
  return ret;
}

void post(problem *p)
{
  int sub;
  FILE *f = fopen("postbest.txt", "r");
  if (f) { printf("error: postbest.txt exists\n"); exit(1); }
  for (sub = 3; sub <= 27; sub++) {
    if (saturation_permute(&p->s[sub*2])) save_best(p, "postbest.txt");
    if (saturation_permute(&p->s[sub*2+1])) save_best(p, "postbest.txt");
  }
}
